/*qmodel1
Constructs q implied by model, using output from "ACQ4.PRG"
*/
environment columns=132
cal 1976 1 12
alloc 100 2800
clear
*
decl ser resid trend trend2 qus qdus
decl int irhoi igammapi igammay igammaq iconst itrend nma
decl real gammapi gammay gammapistar gammaystar gammapitwid gammaytwid gammaq bdisct
decl int nfundmonth ndeterm nlags nseas ibaseyear ibasemo ilastyear ilastmo
decl int jppi jpy jppistar jpystar jppitwid jpytwid jpu jpd
decl int nphimonth nphi ieqn_q
decl int ijunk1 ijunk2 ipicom i2sls nlags
decl label countryid
decl vect[label] varnames
decl string string1 variablename paramname
*just to establish some series names
clear series1 series2 series3 series4 qmodel smodel dqmodel dsmodel
*
source detrend.prg
*
procedure listdata i1 i2 xy xpi xpdcom xi xq xqd
type int i1 i2
type series xy xpi xpdcom xi xq xqd
disp(unit=output) $
"               xy           xpi         xi           xq         xqd"
copy(unit=output,org=obs,dates,format='(a10,9(f9.3,3x))') i1 i2 $
               xy           xpi          xi           xq         xqd
return
end
*
procedure makeseries ieqn model_series cvect var_series1 var_series2 var_series3 var_series4 $
                     nfund nlags ibegin iend
type series *model_series var_series1 var_series2 var_series3 var_series4
type vector cvect
type int nfund nlags ibegin iend
/*
set xpi1 ibegin+1 iend = var_series1(t-1)
set xpi2 ibegin+1 iend = var_series1(t-2)
set xy1 ibegin+1 iend = var_series2(t-1)
set xy2 ibegin+1 iend = var_series2(t-2)
vcv(centered) ibegin iend
#var_series1 var_series2 xpi1 xpi2 xy1 xy2
*/
*coefficients are in cvect.  Up to 4 series in VAR.
if nfund .eq. 1; begin
  equation(coeffs=cvect) ieqn model_series
  #var_series1 {0 to nlags-1}
end; else if nfund .eq. 2; begin
  equation(coeffs=cvect) ieqn model_series
  #var_series1 {0 to nlags-1} var_series2 {0 to nlags-1}
end; else if nfund .eq. 3; begin
  equation(coeffs=cvect) ieqn model_series
  #var_series1 {0 to nlags-1} var_series2 {0 to nlags-1} var_series3 {0 to nlags-1}
end; else if nfund .eq. 4; begin
  equation(coeffs=cvect) ieqn model_series
  #var_series1 {0 to nlags-1} var_series2 {0 to nlags-1} var_series3 {0 to nlags-1} var_series4 {0 to nlags-1}
end
set model_series ibegin ibegin = 0.
smpl ibegin iend
steps 1
#ieqn model_series
disp "makeseries: cvect"
write(noskip,format='(1x,16(f7.2,1x))') cvect
disp "series used in constructing qmodel, then qmodel"
if nfund .eq. 1
  copy(unit=output,org=obs,dates,format='(a10,9(f9.3,3x))') ibegin ibegin+11 $
      var_series1 model_series
if nfund .eq. 2
  copy(unit=output,org=obs,dates,format='(a10,9(f9.3,3x))') ibegin ibegin+11 $
      var_series1 var_series2 model_series
if nfund .eq. 3
  copy(unit=output,org=obs,dates,format='(a10,9(f9.3,3x))') ibegin ibegin+11 $
      var_series1 var_series2 var_series3 model_series
if nfund .eq. 4
  copy(unit=output,org=obs,dates,format='(a10,9(f9.3,3x))') ibegin ibegin+11 $
      var_series1 var_series2 var_series3 var_series4 model_series
*/
return
end
*
procedure checkvar ibegin iend nvar nlags series1 series2 series3 series4 phi errorflag
type int ibegin iend nvar nlags *errorflag
type series series1 series2 series3
type rect phi
local rect mycoeffs checkit
comp xmaxerror=.01
comp errorflag=0
if nvar .eq. 2; begin
  system
  variables series1 series2
  lags 1 to nlags
  det constant
  end(system)
end; else if nvar .eq. 3; begin
  system
  variables series1 series2 series3
  lags 1 to nlags
  det constant
  end(system)
end; else if nvar .eq. 4; begin
  system
  variables series1 series2 series3 series4
  lags 1 to nlags
  det constant
  end(system)
end begin
estimate(noprint,outsigma=mysigma,coeffs=mycoeffs,residual=varresid) ibegin iend
comp checkit = %abs(tr(mycoeffs)-phi)
comp maxdiff = %maxvalue(checkit)
disp "checkvar: maxdiff of VAR and Taylor estimates of VAR" maxdiff
disp(unit=copy) "checkvar: maxdiff of VAR and Taylor estimates of VAR" maxdiff
if maxdiff .gt. xmaxerror; begin
   disp(unit=copy) "Coefficient estimates do not match. Estimates from VAR:"
   write(unit=copy,noskip,format='(1x,16(f7.2,1x))') phi
   disp(unit=copy) "Estimates from CHECKVAR:"
   write(unit=copy,noskip,format='(1x,16(f7.2,1x))') mycoeffs
   disp(unit=copy) "Absolute value of difference: "
   write(unit=copy,noskip,format='(1x,16(f7.2,1x))') checkit
   disp "Coefficient estimates do not match. Estimates from VAR:"
   write(noskip,format='(1x,16(f7.2,1x))') phi
   disp "Estimates from CHECKVAR:"
   write(noskip,format='(1x,16(f7.2,1x))') mycoeffs
   disp "Absolute value of difference: "
   write(noskip,format='(1x,16(f7.2,1x))') checkit
   comp errorflag = 1
end
return
end
*
procedure mean_adjust series1 series2 ibegin iend
type series series1 series2
local series foo
type int ibegin iend
smpl ibegin iend
stat(noprint) series1
comp mean1 = %mean
stat(noprint) series2 ibegin iend
comp mean2 = %mean
set series1 ibegin iend = series1(t) - mean1 + mean2
*/
return
end
*
procedure makename mynames nnames s1 s2 s3 s4 s5 s6 s7 s8
type string *mynames
type int nnames
type series s1 s2 s3 s4 s5 s6 s7 s8
*assumes at least six xeries
if nnames .eq. 6
  disp(store=mynames) @6 %l(s1) @18 %l(s2) @30 %l(s3) @42 %l(s4) @54 %l(s5) @66 %l(s6)
if nnames .eq. 7
  disp(store=mynames) @6 %l(s1) @18 %l(s2) @30 %l(s3) @42 %l(s4) @54 %l(s5) @66 %l(s6) @78 %l(s7)
if nnames .eq. 8
  disp(store=mynames) @6 %l(s1) @18 %l(s2) @30 %l(s3) @42 %l(s4) @54 %l(s5) @66 %l(s6) @78 %l(s7) @90 %l(s8)
return
end
*
procedure printvcv mycov mynames
type sym mycov
type string mynames
*
write(noskip,format='(1x,10(f10.3,2x))') mycov
comp mycorr=mycov
do irow=2,%rows(mycov)
  do icol=1,irow-1
     comp mycorr(irow,icol) = mycov(irow,icol)/sqrt(mycov(irow,irow)*mycov(icol,icol))
  end do
end do
disp mynames
*"qmodel  q      dqmodel  dq      smodel   s      dsmodel  ds"
write(noskip,format='(1x,10(f10.3,2x))') mycorr
disp(unit=copy) "VCV matrices, variances on diagonals, correlations on off diagonals"
disp(unit=copy) mynames
*"qmodel  q      dqmodel  dq      smodel   s      dsmodel  ds"
write(unit=copy,noskip,format='(1x,10(f10.3,2x))') mycorr
*
return
end
*
procedure qcompare qmodel dqmodel dsmodel smodel xq xdq xs xds ibegin iend
type series qmodel dqmodel dsmodel smodel xq xdq xs xds
type int ibegin iend
local real qcorr dqcorr dscorr scorr
local vect corrvect
local series corrseries
local sym mycorr mcov
*
*for some reason %corr seems not to work
disp(unit=output) $
"               q          qmodel       dq         dqmodel      s         smodel       ds         dsmodel"
copy(unit=output,org=obs,dates,format='(a10,9(f9.3,3x))') ibegin ibegin+6 $
                xq           qmodel       xdq          dqmodel      xs        smodel       xds        dsmodel
*/
execute mean_adjust qmodel xq ibegin iend
execute mean_adjust dqmodel xdq ibegin iend
execute mean_adjust dsmodel xds ibegin iend
execute mean_adjust smodel xs ibegin iend
comp qcorr = %corr(qmodel,xq)
cross qmodel xq / 0 0 corrseries
comp qcorr = corrseries(1)
cross dqmodel xdq / 0 0 corrseries
comp dqcorr = corrseries(1)
cross dsmodel xds / 0 0 corrseries
comp dscorr = corrseries(1)
cross smodel xs / 0 0 corrseries
comp scorr = corrseries(1)
disp(unit=copy) "correlation between model and actual q, dq, ds, s: " ##.### @+3 qcorr dqcorr dscorr scorr
disp "correlation between model and actual q, dq, ds, s: " ##.### @+3 qcorr dqcorr dscorr scorr
vcv(noprint,centered,matrix=mycov) ibegin iend
#qmodel xq dqmodel xdq smodel xs dsmodel xds
comp nnames=8
execute makename mynames nnames qmodel xq dqmodel xdq smodel xs dsmodel xds
execute printvcv mycov mynames
*
return
end
*
procedure mystat inseries ibegin iend
type series inseries
type int ibegin iend
local int ncorr
local series corrseries
local label date1 date2 series_name
*
comp date1 = %datelabel(ibegin), date2 = %datelabel(iend)
comp series_name = %l(inseries)
comp ncorr=3
stat(noprint) inseries ibegin iend
corr(noprint,number=ncorr) inseries ibegin iend corrseries
disp series_name @12 date1 '-' date2 @30 ###.### %mean @+3 ##.### %variance ###.### sqrt(%variance) ##.### $
      @+3 corrseries(2) ##.###  @+3 corrseries(3) ##.###  @+3 corrseries(4) ##.###
disp(unit=copy) series_name @12 date1 '-' date2 @30 ###.### %mean @+3 ##.### %variance ###.### sqrt(%variance) ##.### $
      @+3 corrseries(2) ##.###  @+3 corrseries(3) ##.###  @+3 corrseries(4) ##.###
return
end
*
procedure qmoment q dq s ds xpi xy xi i1 i2
type series q dq s ds
type int i1 i2
disp(unit=copy) " "
disp(unit=copy) $
  "series       sample period"  @32 "mean   var     std. dev.  rho(1)   rho(2)  rho(3)"
execute mystat q i1 i2
execute mystat dq i1 i2
execute mystat s i1 i2
execute mystat ds i1 i2
vcv(noprint,centered,matrix=mycov) i1 i2
#q dq s ds xpi xy xi
comp nnames=7
execute makename mynames nnames q dq s ds xpi xy xi series1
disp " "
execute printvcv mycov mynames
return
end
*
procedure makedata q dq s ds nvar nlag ibegin iend country param vname
type series q dq s ds
type int nvar nlag ibegin iend
type label country
type string param vname
comp nlagstring =  %string(nlag)
comp countrystring = %left(country,2)
comp beginyear = %year(ibegin) - 1900
comp endyear = %year(iend) - 1900
if endyear .ge. 100; begin
  if endyear .eq. 100
      comp yearstring = "_" + %string(beginyear) + "00"
  if endyear .eq. 101
      comp yearstring = "_" + %string(beginyear) + "01"
end; else
  comp yearstring = "_" + %string(beginyear) + %string(endyear)
comp stringsuffix = countrystring + "_" + nlagstring + vname + param + yearstring
comp qname = "q" + stringsuffix
comp dqname = "dq" + stringsuffix
comp dsname = "ds" + stringsuffix
comp sname = "s" + stringsuffix
disp(unit=copy) " "
disp(unit=copy) "Variable names in RATS database:" qname dqname dsname sname
dedit(new) qmodel1.rat
*dedit qmodel1.rat
include &qname qmodel
include &dqname dqmodel
include &sname smodel
include &dsname dsmodel

save
*
return
end
*
procedure qmodel1 ibegin iend xylevel1 xpi1 variable3 variable4 $
                     xi1 xqa1 xdqa1 xq1 xdq1 xsa1 xdsa1 xs1 xds1 $
                     country1 xylevel2 xpi2        xi2 country2 cq phi nvar
type series xylevel1 xi1 xqa1 xdqa1 xq1 xdq1 xsa1 xdsa1 xs1 xds1 xpi1 variable3 variable4
type series xylevel2        xi2 country2 xpi2
type vect cq
type rect phi
local series xynow xy1 xy2 xi xq xdq xpimonthly
local label country qname dqname sname dsname
type label country1 country2
type int ibegin iend nvar
local int errorflag
local string countryname nlagstring
*local series smodel
*maximum difference in coefficient estimates between VAR and this program that will be tolerated
*determined by how many digits are written in the input file to this program
disp "data for country 1 (output in levels)"
execute listdata ibegin ibegin+6 xylevel1 xpi1 xi1 xq1 xdq1
disp "data for second country (U.S.) (output in levels)"
execute listdata ibegin ibegin+6 xylevel2 xpi2 xi2 series1 series2
*
set xi = xi1 - xi2
set xpimonthly = xpi1 - xpi2
set xq = xq1
set xdq = xdq1
set xqa = xqa1
set xdqa = xdqa1
comp country = country1 + "/" + country2
execute detrend ibegin iend nlags xylevel1 xy1 xylevel2 xy2 xynow
disp "data for country 2 - country 1 (output detrended)"
execute listdata ibegin ibegin+6 xynow xpimonthly xi xq xdq
disp(unit=copy) varnames
disp(unit=copy) "Information used by ACQ4 in constructing qmodel:"
disp(unit=copy) "  no. of fundamentals, deterministic terms, lags in VAR; flag for annual pi in m rule, no. seasons, start and end date"
disp(unit=copy) nfundmonth ndeterm nlags nseas ibaseyear ibasemo ilastyear ilastmo
disp(unit=copy) $
"      gammapi       gammay      gammapistar gammaystar      gammapitwid    gammaytwid     gammaq        bdisct"
disp(unit=copy) gammapi gammay gammapistar gammaystar gammapitwid gammaytwid gammaq bdisct
disp(unit=copy) "parameter set name"
disp(unit=copy) paramname
disp(unit=copy) "Model q constructed with the following weights (cq):"
write(unit=copy,noskip,format='(1x,16(f8.4,1x))') cq
*check to make sure that we're using the right data
execute checkvar ibegin iend nvar nlags xpimonthly xynow variable3 variable4 phi errorflag
if errorflag .eq. 0; begin
   if nvar .eq. 2
      execute makeseries ieqn_q qmodel cq xpimonthly xynow series3 series4 $
                     nvar nlags ibegin iend
   if nvar .eq. 3
      execute makeseries ieqn_q qmodel cq xpimonthly xynow variable3 series4 $
                     nvar nlags ibegin iend
   if nvar .eq. 4
      execute makeseries ieqn_q qmodel cq xpimonthly xynow variable3 variable4 $
                     nvar nlags ibegin iend
   set dqmodel = qmodel(t)-qmodel(t-1)
   set dsmodel = dqmodel + xpimonthly
   accumulate dsmodel ibegin iend smodel ibegin
   execute qmoment qmodel dqmodel dsmodel smodel xpimonthly xynow xi ibegin iend
   disp(unit=copy) " "
   disp(unit=copy) "Comparison to actual data (point in time)"
   execute qcompare qmodel dqmodel dsmodel smodel xq xdq xs1 xds1 ibegin iend
   disp(unit=copy) " "
   disp(unit=copy) "Comparison to actual data (period average)"
   execute qcompare qmodel dqmodel dsmodel smodel xqa xdqa xsa1 xdsa1 ibegin iend
   execute makedata qmodel dqmodel smodel dsmodel nvar nlags ibegin iend country1 paramname variablename
end begin
 
*
return
end
**************************************************************************************
**********************
open data qmodel1.inp
read(unit=data) countryid
read(unit=data) string1
read(unit=data) nfundmonth ndeterm nlags nseas ibaseyear ibasemo ilastyear ilastmo
dim varnames(nfundmonth)
read(unit=data) varnames
disp varnames(1) varnames(2)
read(unit=data) variablename
disp variablename
comp nphimonth = nfundmonth*nlags
comp nphi=nlags*nfundmonth + (nseas-nlags)
decl rect phi(nphi,nphi) phimonth(nfundmonth,nphimonth+ndeterm)
decl sym varZe(nphi,nphi) varZemonth(nfundmonth,nfundmonth)
decl vect cz(nphi) cq(nphi) ci(nphi) cpi_e_month(nphimonth) cqvar(nphimonth)
read(unit=data) string1
read(unit=data) gammapi gammay gammapistar gammaystar gammapitwid gammaytwid gammaq bdisct
read(unit=data) string1
read(unit=data) paramname
read(unit=data) string1
read(unit=data) jppi jpy jppistar jpystar jppitwid jpytwid jpu jpd
read(unit=data) string1
read(unit=data) cpi_e_month
read(unit=data) cz
read(unit=data) cq
read(unit=data) ci
read(unit=data) string1
read(unit=data) phimonth
read(unit=data) string1
read(unit=data) varZemonth
close data
do ii=1,nphimonth
  comp cqvar(ii) = cq(ii)
end do
write(noskip,format='(1x,16(f7.2,1x))') varZemonth
write(noskip,format='(1x,16(f7.2,1x))') phimonth
disp countryid
disp nfundmonth nlags nseas ibaseyear ibasemo ilastyear ilastmo
disp gammapi gammay gammapistar gammaystar gammapitwid gammaytwid gammaq bdisct
disp jppi jpy jppistar jpystar jppitwid jpytwid jpu jpd
disp cpi_e_month
set trend /= t
set trend2 /= t*t
comp nma=24
input irhoi igammapi igammay igammaq iconst itrend
         4       2      3       5      1       6
comp igammaq=0
*
open copy qmodel1.out
comp ibase=%cal(ibaseyear,ibasemo), last=%cal(ilastyear,ilastmo)
disp ibase last
disp ibaseyear ibasemo
comp ifirst=ibase-24, ieqn_q =1
*
open data isomge.rat
if nfundmonth .eq. 2; begin
  labels       1        2
#         varnames(1) varnames(2)
  data(format=rats) ifirst last 1 2
end; else if nfundmonth  .eq. 3; begin
  labels    1    2       3
#        varnames(1) varnames(2) varnames(3)
  data(format=rats) ifirst last 1 2 3
end; if nfundmonth  .eq. 4; begin
  labels      1          2        3          4
#        varnames(1) varnames(2)  varnames(3) varnames(4)
  data(format=rats) ifirst last 1 2 3 4
end begin
end if
  data(format=rats) / IGE PGE QDGE QGE IUS PUS YUS PDUS QAGE QADGE SAGE SADGE SGE SDGE
  disp(unit=copy) "qmodel1.prg: Germany-U.S."
  execute qmodel1 ibase last 1 2 3 4 $
                                            ige qage qadge qge qdge sage sadge sge sdge countryid $
                             yus pdus       ius 'US' cqvar phimonth nfundmonth
*/
close data
end
end
end
